import { clsx } from 'clsx';
export { clsx } from 'clsx';

const matches = (c, o) => Array.isArray(c) ? c.includes(o) : c === o;
const onno = ({
  compound = [],
  baseline,
  defaults,
  variants
}) => {
  if (variants.className) {
    throw new Error(`"className" cannot be used as a variant name`);
  }
  const cl = compound.length || 1;
  const cn = compound.map((c) => c.className);
  return (options) => {
    const vc = [];
    const cc = [...cn];
    for (let i = 0; i < cl; i++) {
      for (const k in variants) {
        const o = options?.[k] ?? defaults?.[k];
        const c = compound[i]?.[k];
        const v = variants[k];
        if (!i && o && v)
          vc.push(v[o] ?? v);
        if (c && cc[i] && !matches(c, o))
          cc[i] = "";
      }
    }
    return clsx(baseline, vc, cc, options?.className);
  };
};

export { onno };
